Index: /ccr/trunk/kids/CCD-CCR_GENERATION_UTILITIES_1P2.KID
===================================================================
--- /ccr/trunk/kids/CCD-CCR_GENERATION_UTILITIES_1P2.KID	(revision 1586)
+++ /ccr/trunk/kids/CCD-CCR_GENERATION_UTILITIES_1P2.KID	(revision 1587)
@@ -103310,743 +103346,737 @@
  ;   rcr@rcresearch.us
 "RTN","C0CMAIL",6,0)
- ;  Licensed under the terms of the GNU
+ ;
 "RTN","C0CMAIL",7,0)
- ;General Public License See attached copy of the License.
+ ; This program is free software: you can redistribute it and/or modify
 "RTN","C0CMAIL",8,0)
- ;
+ ; it under the terms of the GNU Affero General Public License as
 "RTN","C0CMAIL",9,0)
- ;This program is free software; you can redistribute it and/or modify
+ ; published by the Free Software Foundation, either version 3 of the
 "RTN","C0CMAIL",10,0)
- ;it under the terms of the GNU General Public License as published by
+ ; License, or (at your option) any later version.
 "RTN","C0CMAIL",11,0)
- ;the Free Software Foundation; either version 2 of the License, or
+ ;
 "RTN","C0CMAIL",12,0)
- ;(at your option) any later version.
+ ; This program is distributed in the hope that it will be useful,
 "RTN","C0CMAIL",13,0)
- ;
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 "RTN","C0CMAIL",14,0)
- ;This program is distributed in the hope that it will be useful,
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 "RTN","C0CMAIL",15,0)
- ;but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ; GNU Affero General Public License for more details.
 "RTN","C0CMAIL",16,0)
- ;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ;
 "RTN","C0CMAIL",17,0)
- ;GNU General Public License for more details.
+ ; You should have received a copy of the GNU Affero General Public License
 "RTN","C0CMAIL",18,0)
- ;
+ ; along with this program.  If not, see <http://www.gnu.org/licenses/>.
 "RTN","C0CMAIL",19,0)
- ;You should have received a copy of the GNU General Public License along
+ ;
 "RTN","C0CMAIL",20,0)
- ;with this program; if not, write to the Free Software Foundation, Inc.,
+ ;  ------------------
 "RTN","C0CMAIL",21,0)
- ;51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ ;Entry Points
 "RTN","C0CMAIL",22,0)
- ;
+ ; GETMSG^C0CMAIL(.C0CDATA,.C0CINPUT)
 "RTN","C0CMAIL",23,0)
- ;  ------------------
+ ;  Input:
 "RTN","C0CMAIL",24,0)
- ;Entry Points
+ ;    C0CINPUT = "DUZ;MAILBOX_Name[or IEN for box (comma Separated);MALL
 "RTN","C0CMAIL",25,0)
- ; GETMSG^C0CMAIL(.C0CDATA,.C0CINPUT)
+ ;                      or "*" for all boxes, default is "IN" if missing]"
 "RTN","C0CMAIL",26,0)
- ;  Input:
+ ;                $P(C0CINPUT,";",3)=MALL, default=NUL means "New only",
 "RTN","C0CMAIL",27,0)
- ;    C0CINPUT = "DUZ;MAILBOX_Name[or IEN for box (comma Separated);MALL
+ ;                                     "*" for All or 9,999 maximum
 "RTN","C0CMAIL",28,0)
- ;                      or "*" for all boxes, default is "IN" if missing]"
+ ;                    MALL?1.n = that number of the n most recent
 "RTN","C0CMAIL",29,0)
- ;                $P(C0CINPUT,";",3)=MALL, default=NUL means "New only",
+ ;  Internally:
 "RTN","C0CMAIL",30,0)
- ;                                     "*" for All or 9,999 maximum
+ ;    BNAM = Box Name
 "RTN","C0CMAIL",31,0)
- ;                    MALL?1.n = that number of the n most recent
+ ;  Output:
 "RTN","C0CMAIL",32,0)
- ;  Internally:
+ ;    C0CDATA
 "RTN","C0CMAIL",33,0)
- ;    BNAM = Box Name
+ ;      = (BNAM,"NUMBER") = Number of NEW Emails in Basket
 "RTN","C0CMAIL",34,0)
- ;  Output:
+ ;        (BNAM,"MSG",C0CIEN,"FROM")=Name
 "RTN","C0CMAIL",35,0)
- ;    C0CDATA
+ ;        (BNAM,"MSG",C0CIEN,"TO",n)=DUZ, or EMAIL Address
 "RTN","C0CMAIL",36,0)
- ;      = (BNAM,"NUMBER") = Number of NEW Emails in Basket
+ ;        (BNAM,"MSG",C0CIEN,"TO NAME",n)=Names or EMAIL Address
 "RTN","C0CMAIL",37,0)
- ;        (BNAM,"MSG",C0CIEN,"FROM")=Name
+ ;        (BNAM,"MSG",C0CIEN,"TITLE")=EMAIL Title
 "RTN","C0CMAIL",38,0)
- ;        (BNAM,"MSG",C0CIEN,"TO",n)=DUZ, or EMAIL Address
+ ;        (BNAM,"MSG",C0CIEN[for File 3.9])=Number of Attachments
 "RTN","C0CMAIL",39,0)
- ;        (BNAM,"MSG",C0CIEN,"TO NAME",n)=Names or EMAIL Address
+ ;        (BNAM,"MSG",C0CIEN,num,"CONT") = Free Text
 "RTN","C0CMAIL",40,0)
- ;        (BNAM,"MSG",C0CIEN,"TITLE")=EMAIL Title
+ ;        (BNAM,"MSG",C0CIEN,num,"LINES") = Number of Lines of Text
 "RTN","C0CMAIL",41,0)
- ;        (BNAM,"MSG",C0CIEN[for File 3.9])=Number of Attachments
+ ;        (BNAM,"MSG",C0CIEN,num,"SIZE") = Size of the Message in Bytes
 "RTN","C0CMAIL",42,0)
- ;        (BNAM,"MSG",C0CIEN,num,"CONT") = Free Text
+ ;        (BNAM,"MSG",C0CIEN,num,"TXT",LINE#) = Message Data (No Attachment)
 "RTN","C0CMAIL",43,0)
- ;        (BNAM,"MSG",C0CIEN,num,"LINES") = Number of Lines of Text
+ ;   (BNAM,"MSG",C0CIEN,"SEG",NUM) = First Line^Last Line
 "RTN","C0CMAIL",44,0)
- ;        (BNAM,"MSG",C0CIEN,num,"SIZE") = Size of the Message in Bytes
+ ;   (BNAM,"MSG",C0CIEN,"SEG",NUM,"CONT",type) = Message Details
 "RTN","C0CMAIL",45,0)
- ;        (BNAM,"MSG",C0CIEN,num,"TXT",LINE#) = Message Data (No Attachment)
+ ;   (BNAM,"MSG",C0CIEN,"SEG",NUM,LINE#) = Message Data
 "RTN","C0CMAIL",46,0)
- ;   (BNAM,"MSG",C0CIEN,"SEG",NUM) = First Line^Last Line
+ ; 
 "RTN","C0CMAIL",47,0)
- ;   (BNAM,"MSG",C0CIEN,"SEG",NUM,"CONT",type) = Message Details
+ ; DO DETAIL^C0CMAIL(.OUTBF,D0) ; For each Email Message and Attachments
 "RTN","C0CMAIL",48,0)
- ;   (BNAM,"MSG",C0CIEN,"SEG",NUM,LINE#) = Message Data
+ ;   Input;
 "RTN","C0CMAIL",49,0)
+ ;     D0     - The IEN for the message in file 3.9, MESSAGE global
+"RTN","C0CMAIL",50,0)
+ ;   Output
+"RTN","C0CMAIL",51,0)
+ ;     OUTBF  - The array of your choice to save the expanded and decoded message.
+"RTN","C0CMAIL",52,0)
  ; 
-"RTN","C0CMAIL",50,0)
- ; DO DETAIL^C0CMAIL(.OUTBF,D0) ; For each Email Message and Attachments
-"RTN","C0CMAIL",51,0)
- ;   Input;
-"RTN","C0CMAIL",52,0)
- ;     D0     - The IEN for the message in file 3.9, MESSAGE global
 "RTN","C0CMAIL",53,0)
- ;   Output
+GETMSG(C0CDATA,C0CINPUT) ; Common Entry Point for Mailbox Data
 "RTN","C0CMAIL",54,0)
- ;     OUTBF  - The array of your choice to save the expanded and decoded message.
+ K:'$G(C0CDATA("KEEP")) C0CDATA
 "RTN","C0CMAIL",55,0)
- ; 
+ N U
 "RTN","C0CMAIL",56,0)
-GETMSG(C0CDATA,C0CINPUT) ; Common Entry Point for Mailbox Data
+ S U="^"
 "RTN","C0CMAIL",57,0)
- K:'$G(C0CDATA("KEEP")) C0CDATA
+ D:$G(C0CINPUT)
 "RTN","C0CMAIL",58,0)
- N U
+ . N BF,DUZ,I,INPUT,J,L,LST,MBLST,MALL
 "RTN","C0CMAIL",59,0)
- S U="^"
+ . S INPUT=C0CINPUT
 "RTN","C0CMAIL",60,0)
- D:$G(C0CINPUT)
+ . S DUZ=+INPUT
 "RTN","C0CMAIL",61,0)
- . N BF,DUZ,I,INPUT,J,L,LST,MBLST,MALL
+ . D:$D(^XMB(3.7,DUZ,0))#2
 "RTN","C0CMAIL",62,0)
- . S INPUT=C0CINPUT
+ . . S MBLST=$P(INPUT,";",2)
 "RTN","C0CMAIL",63,0)
- . S DUZ=+INPUT
+ . . S MALL=$P(INPUT,";",3) ; New or All Mail Flag
 "RTN","C0CMAIL",64,0)
- . D:$D(^XMB(3.7,DUZ,0))#2
+ . . S:MALL["*" MALL=99999
 "RTN","C0CMAIL",65,0)
- . . S MBLST=$P(INPUT,";",2)
+ . . ; Only one of these can be correct
 "RTN","C0CMAIL",66,0)
- . . S MALL=$P(INPUT,";",3) ; New or All Mail Flag
+ . . D
 "RTN","C0CMAIL",67,0)
- . . S:MALL["*" MALL=99999
+ . . . ;  If nul, make it "IN" only
 "RTN","C0CMAIL",68,0)
- . . ; Only one of these can be correct
+ . . . I MBLST="" D  QUIT
 "RTN","C0CMAIL",69,0)
- . . D
+ . . . . S MBLST("IN")=0,I=0
 "RTN","C0CMAIL",70,0)
- . . . ;  If nul, make it "IN" only
+ . . . . D GATHER(DUZ,"IN",.LST)
 "RTN","C0CMAIL",71,0)
- . . . I MBLST="" D  QUIT
+ . . . .QUIT
 "RTN","C0CMAIL",72,0)
- . . . . S MBLST("IN")=0,I=0
+ . . . ;
 "RTN","C0CMAIL",73,0)
- . . . . D GATHER(DUZ,"IN",.LST)
+ . . . ;  If "*", Get all Mailboxes and look for New Messages
 "RTN","C0CMAIL",74,0)
+ . . . I MBLST["*" D  QUIT
+"RTN","C0CMAIL",75,0)
+ . . . . N NAM,NUM
+"RTN","C0CMAIL",76,0)
+ . . . . S NUM=0
+"RTN","C0CMAIL",77,0)
+ . . . . F  S NUM=$O(^XMB(3.7,DUZ,2,NUM)) Q:'NUM  D
+"RTN","C0CMAIL",78,0)
+ . . . . . S NAM=$P(^XMB(3.7,DUZ,2,NUM,0),U)
+"RTN","C0CMAIL",79,0)
+ . . . . . D GATHER(DUZ,NAM,.LST)
+"RTN","C0CMAIL",80,0)
+ . . . . .QUIT
+"RTN","C0CMAIL",81,0)
  . . . .QUIT
-"RTN","C0CMAIL",75,0)
+"RTN","C0CMAIL",82,0)
  . . . ;
-"RTN","C0CMAIL",76,0)
- . . . ;  If "*", Get all Mailboxes and look for New Messages
-"RTN","C0CMAIL",77,0)
- . . . I MBLST["*" D  QUIT
-"RTN","C0CMAIL",78,0)
- . . . . N NAM,NUM
-"RTN","C0CMAIL",79,0)
- . . . . S NUM=0
-"RTN","C0CMAIL",80,0)
- . . . . F  S NUM=$O(^XMB(3.7,DUZ,2,NUM)) Q:'NUM  D
-"RTN","C0CMAIL",81,0)
- . . . . . S NAM=$P(^XMB(3.7,DUZ,2,NUM,0),U)
-"RTN","C0CMAIL",82,0)
+"RTN","C0CMAIL",83,0)
+ . . . ;  If comma separated, look for mailboxes with new messages
+"RTN","C0CMAIL",84,0)
+ . . . I $L(MBLST,",")>1 D  QUIT
+"RTN","C0CMAIL",85,0)
+ . . . . S NAM=""
+"RTN","C0CMAIL",86,0)
+ . . . . N T,V
+"RTN","C0CMAIL",87,0)
+ . . . . F T=1:1:$L(MBLST,",")  S V=$P(MBLST,",",T)  I $L(V) D
+"RTN","C0CMAIL",88,0)
+ . . . . . I V S NAM=$P($G(^XMB(3.7,DUZ,2,V,0)),U)
+"RTN","C0CMAIL",89,0)
+ . . . . . S:NAM="" NAM=V
+"RTN","C0CMAIL",90,0)
  . . . . . D GATHER(DUZ,NAM,.LST)
-"RTN","C0CMAIL",83,0)
+"RTN","C0CMAIL",91,0)
  . . . . .QUIT
-"RTN","C0CMAIL",84,0)
+"RTN","C0CMAIL",92,0)
  . . . .QUIT
-"RTN","C0CMAIL",85,0)
+"RTN","C0CMAIL",93,0)
  . . . ;
-"RTN","C0CMAIL",86,0)
- . . . ;  If comma separated, look for mailboxes with new messages
-"RTN","C0CMAIL",87,0)
- . . . I $L(MBLST,",")>1 D  QUIT
-"RTN","C0CMAIL",88,0)
- . . . . S NAM=""
-"RTN","C0CMAIL",89,0)
- . . . . N T,V
-"RTN","C0CMAIL",90,0)
- . . . . F T=1:1:$L(MBLST,",")  S V=$P(MBLST,",",T)  I $L(V) D
-"RTN","C0CMAIL",91,0)
- . . . . . I V S NAM=$P($G(^XMB(3.7,DUZ,2,V,0)),U)
-"RTN","C0CMAIL",92,0)
- . . . . . S:NAM="" NAM=V
-"RTN","C0CMAIL",93,0)
- . . . . . D GATHER(DUZ,NAM,.LST)
 "RTN","C0CMAIL",94,0)
- . . . . .QUIT
+ . . . ;  If only 1 mailbox named, go get it
 "RTN","C0CMAIL",95,0)
- . . . .QUIT
+ . . . I $L(MBLST) D GATHER(DUZ,MBLST,.LST) QUIT
 "RTN","C0CMAIL",96,0)
- . . . ;
+ . . .QUIT
 "RTN","C0CMAIL",97,0)
- . . . ;  If only 1 mailbox named, go get it
+ . . MERGE C0CDATA=LST
 "RTN","C0CMAIL",98,0)
- . . . I $L(MBLST) D GATHER(DUZ,MBLST,.LST) QUIT
+ . .QUIT
 "RTN","C0CMAIL",99,0)
- . . .QUIT
+ .QUIT
 "RTN","C0CMAIL",100,0)
- . . MERGE C0CDATA=LST
+ QUIT
 "RTN","C0CMAIL",101,0)
+ ;  ===================
+"RTN","C0CMAIL",102,0)
+GATHER(DUZ,NAM,LST) ; Gather Data about the Baskets and their mail
+"RTN","C0CMAIL",103,0)
+ N I,J,K,L
+"RTN","C0CMAIL",104,0)
+ S (I,K)=0
+"RTN","C0CMAIL",105,0)
+ S J=$O(^XMB(3.7,DUZ,2,"B",NAM,""))
+"RTN","C0CMAIL",106,0)
+ F  S I=$O(^XMB(3.7,DUZ,2,J,1,I)) Q:'I  D
+"RTN","C0CMAIL",107,0)
+ . S L=$P(^XMB(3.7,DUZ,2,J,1,I,0),U,3)
+"RTN","C0CMAIL",108,0)
+ . D   ; :L
+"RTN","C0CMAIL",109,0)
+ . . S:L K=K+1,LST(NAM,"MSG",I,"NEW")=""  ; Flag NEW emails
+"RTN","C0CMAIL",110,0)
+ . . S LST(NAM,"MSG",I)=L
+"RTN","C0CMAIL",111,0)
+ . . D GETTYP(I)
+"RTN","C0CMAIL",112,0)
  . .QUIT
-"RTN","C0CMAIL",102,0)
+"RTN","C0CMAIL",113,0)
  .QUIT
-"RTN","C0CMAIL",103,0)
+"RTN","C0CMAIL",114,0)
+ S LST(NAM,"NUMBER")=K
+"RTN","C0CMAIL",115,0)
  QUIT
-"RTN","C0CMAIL",104,0)
+"RTN","C0CMAIL",116,0)
  ;  ===================
-"RTN","C0CMAIL",105,0)
-GATHER(DUZ,NAM,LST) ; Gather Data about the Baskets and their mail
-"RTN","C0CMAIL",106,0)
- N I,J,K,L
-"RTN","C0CMAIL",107,0)
- S (I,K)=0
-"RTN","C0CMAIL",108,0)
- S J=$O(^XMB(3.7,DUZ,2,"B",NAM,""))
-"RTN","C0CMAIL",109,0)
- F  S I=$O(^XMB(3.7,DUZ,2,J,1,I)) Q:'I  D
-"RTN","C0CMAIL",110,0)
- . S L=$P(^XMB(3.7,DUZ,2,J,1,I,0),U,3)
-"RTN","C0CMAIL",111,0)
- . D   ; :L
-"RTN","C0CMAIL",112,0)
- . . S:L K=K+1,LST(NAM,"MSG",I,"NEW")=""  ; Flag NEW emails
-"RTN","C0CMAIL",113,0)
- . . S LST(NAM,"MSG",I)=L
-"RTN","C0CMAIL",114,0)
- . . D GETTYP(I)
-"RTN","C0CMAIL",115,0)
- . .QUIT
-"RTN","C0CMAIL",116,0)
- .QUIT
 "RTN","C0CMAIL",117,0)
- S LST(NAM,"NUMBER")=K
+ ; D0 is the IEN into the Message Global ^XMB(3.9,D0)
 "RTN","C0CMAIL",118,0)
- QUIT
+ ; The products of these emails are scanned to identify
 "RTN","C0CMAIL",119,0)
- ;  ===================
+ ;  the number of documents stored in the MIME package.
 "RTN","C0CMAIL",120,0)
- ; D0 is the IEN into the Message Global ^XMB(3.9,D0)
+ ;  The protocol runs like this;
 "RTN","C0CMAIL",121,0)
- ; The products of these emails are scanned to identify
+ ; Line 1 is the --separator
 "RTN","C0CMAIL",122,0)
- ;  the number of documents stored in the MIME package.
+ ; Line 2 thru n >Look for Content-[detail type:]Description ; Next CMD
 "RTN","C0CMAIL",123,0)
- ;  The protocol runs like this;
+ ; Line n+2 thru t-1 where t does NOT have "Content-"
 "RTN","C0CMAIL",124,0)
- ; Line 1 is the --separator
+ ; Line t   is Next Section Terminator, or Message Terminator, --separator
 "RTN","C0CMAIL",125,0)
- ; Line 2 thru n >Look for Content-[detail type:]Description ; Next CMD
+ ; Line t+1 should not exist in the data set if Message Terminator
 "RTN","C0CMAIL",126,0)
- ; Line n+2 thru t-1 where t does NOT have "Content-"
+ ; CON = "Content-"
 "RTN","C0CMAIL",127,0)
- ; Line t   is Next Section Terminator, or Message Terminator, --separator
+ ; FLG = "--"
 "RTN","C0CMAIL",128,0)
- ; Line t+1 should not exist in the data set if Message Terminator
+ ; SEP = FLG+7 or more characters  ; Separator
 "RTN","C0CMAIL",129,0)
- ; CON = "Content-"
+ ; END = SEP+FLG
 "RTN","C0CMAIL",130,0)
- ; FLG = "--"
+ ; SGC = Segment Count
 "RTN","C0CMAIL",131,0)
- ; SEP = FLG+7 or more characters  ; Separator
+ ; Note: separator is a string of specific characters of
 "RTN","C0CMAIL",132,0)
- ; END = SEP+FLG
+ ;        indeterminate length  
 "RTN","C0CMAIL",133,0)
- ; SGC = Segment Count
+ ; LST() the transfer array
 "RTN","C0CMAIL",134,0)
- ; Note: separator is a string of specific characters of
+ ; LST(NAM,"MSG",C0CIEN,"SEG",SGN)=Starting Line^Ending Line
 "RTN","C0CMAIL",135,0)
- ;        indeterminate length  
+ ; LST(NAM,"MSG",C0CIEN,"SEG",SGN,1:n)=Decoded Message Data
 "RTN","C0CMAIL",136,0)
- ; LST() the transfer array
+ ;
 "RTN","C0CMAIL",137,0)
- ; LST(NAM,"MSG",C0CIEN,"SEG",SGN)=Starting Line^Ending Line
+GETTYP(D0) ; Look for the goodies in the Mail
 "RTN","C0CMAIL",138,0)
- ; LST(NAM,"MSG",C0CIEN,"SEG",SGN,1:n)=Decoded Message Data
+ N I,J,N,BCN,CON,CNT,D1,END,FLG,SEP,SGC,XX,XXNM
 "RTN","C0CMAIL",139,0)
- ;
+ S CON="Content-"
 "RTN","C0CMAIL",140,0)
-GETTYP(D0) ; Look for the goodies in the Mail
+ S FLG="--"
 "RTN","C0CMAIL",141,0)
- N I,J,N,BCN,CON,CNT,D1,END,FLG,SEP,SGC,XX,XXNM
+ S SEP=""  ; Start SEP as null, so we can use this to help identify the type
 "RTN","C0CMAIL",142,0)
- S CON="Content-"
+ S (BCN,CNT,D1,END,SGC)=0
 "RTN","C0CMAIL",143,0)
- S FLG="--"
+ S XX=$G(^XMB(3.9,D0,0))
 "RTN","C0CMAIL",144,0)
- S SEP=""  ; Start SEP as null, so we can use this to help identify the type
+ S LST(NAM,"MSG",D0,"TITLE")=$P($G(^XMB(3.9,D0,0)),U,1)
 "RTN","C0CMAIL",145,0)
- S (BCN,CNT,D1,END,SGC)=0
+ S LST(NAM,"MSG",D0,"CREATED")=$G(^XMB(3.9,D0,.6))
 "RTN","C0CMAIL",146,0)
- S XX=$G(^XMB(3.9,D0,0))
+ F I=4,2 S XXNM=$P(XX,U,I)  Q:$L(XXNM)
 "RTN","C0CMAIL",147,0)
- S LST(NAM,"MSG",D0,"TITLE")=$P($G(^XMB(3.9,D0,0)),U,1)
+ S LST(NAM,"MSG",D0,"FROM")=$$NAME(XXNM)
 "RTN","C0CMAIL",148,0)
- S LST(NAM,"MSG",D0,"CREATED")=$G(^XMB(3.9,D0,.6))
+ S LST(NAM,"MSG",D0,"SENT")=$$TIME($P(XX,U,3))
 "RTN","C0CMAIL",149,0)
- F I=4,2 S XXNM=$P(XX,U,I)  Q:$L(XXNM)
+ ; Get the folks the email is sent to.
 "RTN","C0CMAIL",150,0)
- S LST(NAM,"MSG",D0,"FROM")=$$NAME(XXNM)
+ S D1=0
 "RTN","C0CMAIL",151,0)
- S LST(NAM,"MSG",D0,"SENT")=$$TIME($P(XX,U,3))
+ F  S D1=$O(^XMB(3.9,D0,1,D1)) Q:'D1  D
 "RTN","C0CMAIL",152,0)
- ; Get the folks the email is sent to.
+ . N T
 "RTN","C0CMAIL",153,0)
- S D1=0
+ . S T=+$G(^XMB(3.9,D0,1,D1,0))
 "RTN","C0CMAIL",154,0)
- F  S D1=$O(^XMB(3.9,D0,1,D1)) Q:'D1  D
+ . S:T T=$P($G(^VA(200,+T,0)),"^")
 "RTN","C0CMAIL",155,0)
- . N T
+ . S LST("TO",D1)=T
 "RTN","C0CMAIL",156,0)
- . S T=+$G(^XMB(3.9,D0,1,D1,0))
+ . S T=$G(^XMB(3.9,D0,6,D1,0))
 "RTN","C0CMAIL",157,0)
  . S:T T=$P($G(^VA(200,+T,0)),"^")
 "RTN","C0CMAIL",158,0)
- . S LST("TO",D1)=T
+ . S:T="" T="<Unknown>"
 "RTN","C0CMAIL",159,0)
- . S T=$G(^XMB(3.9,D0,6,D1,0))
+ . S LST("TO NAME",D1)=T
 "RTN","C0CMAIL",160,0)
- . S:T T=$P($G(^VA(200,+T,0)),"^")
+ .QUIT
 "RTN","C0CMAIL",161,0)
+ ; Preload first Segment (0) with beginning on Line 1
+"RTN","C0CMAIL",162,0)
+ ;  if not a 64bit
+"RTN","C0CMAIL",163,0)
+ S LST(NAM,"MSG",D0,"SEG",0)=1
+"RTN","C0CMAIL",164,0)
+ S D1=.9999,SEP="--"
+"RTN","C0CMAIL",165,0)
+ F  S D1=$O(^XMB(3.9,D0,2,D1)) Q:'D1  D
+"RTN","C0CMAIL",166,0)
+ . ; Clear any control characters (cr/lf/ff) off
+"RTN","C0CMAIL",167,0)
+ . S X=$TR($G(^XMB(3.9,D0,2,D1,0)),$C(10,12,13))
+"RTN","C0CMAIL",168,0)
+ . ; Enter once to set the SEP to capture the separator
+"RTN","C0CMAIL",169,0)
+ . I SEP=FLG&($E(X,1,2)=FLG)&($L(X,FLG)=2)&($L($P(X,FLG,2)>5))   D   Q
+"RTN","C0CMAIL",170,0)
+ . . S SEP=X,END=X_FLG
+"RTN","C0CMAIL",171,0)
+ . . S (CNT,SGC)=1,BCN=0
+"RTN","C0CMAIL",172,0)
+ . . S LST(NAM,"MSG",D0,"SEG",SGC)=D1
+"RTN","C0CMAIL",173,0)
+ . .QUIT
+"RTN","C0CMAIL",174,0)
+ . ;
+"RTN","C0CMAIL",175,0)
+ . ; A new separator is set, process original 
+"RTN","C0CMAIL",176,0)
+ . I X=SEP  D  QUIT
+"RTN","C0CMAIL",177,0)
+ . . S LST(NAM,"MSG",D0,SGC,"SIZE")=BCN
+"RTN","C0CMAIL",178,0)
+ . . S LST(NAM,"MSG",D0,"SEG",SGC)=$G(LST(NAM,"MSG",D0,"SEG",SGC))_"^"_(D1-1)
+"RTN","C0CMAIL",179,0)
+ . . S SGC=SGC+1,BCN=0
+"RTN","C0CMAIL",180,0)
+ . . S LST(NAM,"MSG",D0,"SEG",SGC)=D1
+"RTN","C0CMAIL",181,0)
+ . .QUIT
+"RTN","C0CMAIL",182,0)
+ . ;
+"RTN","C0CMAIL",183,0)
+ . S BCN=BCN+$L(X)
+"RTN","C0CMAIL",184,0)
+ . I X[CON D  Q
+"RTN","C0CMAIL",185,0)
+ . . S J=$P($P(X,";"),CON,2)
+"RTN","C0CMAIL",186,0)
+ . . S LST(NAM,"MSG",D0,"SEG",SGC,"CONT",CNT,$P(J,":"))=$P(J,":",2)
+"RTN","C0CMAIL",187,0)
+ . .QUIT
+"RTN","C0CMAIL",188,0)
+ . ;
+"RTN","C0CMAIL",189,0)
+ . ; S LST(NAM,"MSG",D0,"SEG",D1)=X
+"RTN","C0CMAIL",190,0)
+ .QUIT
+"RTN","C0CMAIL",191,0)
+ QUIT
+"RTN","C0CMAIL",192,0)
+ ;  ===================
+"RTN","C0CMAIL",193,0)
+NAME(NM) ; Return the name of the Sender
+"RTN","C0CMAIL",194,0)
+ N NAME
+"RTN","C0CMAIL",195,0)
+ S NAME="<Unknown Sender>"
+"RTN","C0CMAIL",196,0)
+ D
+"RTN","C0CMAIL",197,0)
+ . ; Look first for a value to use with the NEW PERSON file
+"RTN","C0CMAIL",198,0)
+ . ;
+"RTN","C0CMAIL",199,0)
+ . I NM=+NM S NAME=$P(^VA(200,NM,0),U,1) Q
+"RTN","C0CMAIL",200,0)
+ . ;
+"RTN","C0CMAIL",201,0)
+ . I $L(NM) S NAME=NM                    Q
+"RTN","C0CMAIL",202,0)
+ . ;
+"RTN","C0CMAIL",203,0)
+ . ; Else, pull the data from the message and display the foreign source
+"RTN","C0CMAIL",204,0)
+ . ;   of the message.
+"RTN","C0CMAIL",205,0)
+ . N T
+"RTN","C0CMAIL",206,0)
+ . S VAL=$G(^XMB(3.9,D0,.7))
+"RTN","C0CMAIL",207,0)
+ . S:VAL T=$P(^VA(200,VAL,0),U)
+"RTN","C0CMAIL",208,0)
+ . I $L($G(T)) S NAME=T                  Q
+"RTN","C0CMAIL",209,0)
+ . ;
+"RTN","C0CMAIL",210,0)
+ .QUIT
+"RTN","C0CMAIL",211,0)
+ QUIT NAME
+"RTN","C0CMAIL",212,0)
+ ;  ===================
+"RTN","C0CMAIL",213,0)
+TIME(Y) ; The time and date of the sending
+"RTN","C0CMAIL",214,0)
+ X ^DD("DD")
+"RTN","C0CMAIL",215,0)
+ QUIT Y
+"RTN","C0CMAIL",216,0)
+ ;  ===================
+"RTN","C0CMAIL",217,0)
+ ;  Segments in Message need to be identified and decoded properly
+"RTN","C0CMAIL",218,0)
+ ; D DETAIL^C0CMAIL(.ARRAY,D0) ;  Call One for each message
+"RTN","C0CMAIL",219,0)
+ ;   ARRAY will have the details of this one call
+"RTN","C0CMAIL",220,0)
+ ;    
+"RTN","C0CMAIL",221,0)
+ ; Inputs;
+"RTN","C0CMAIL",222,0)
+ ;   C0CINPUT    - The IEN of the message to expand
+"RTN","C0CMAIL",223,0)
+ ; Outputs;
+"RTN","C0CMAIL",224,0)
+ ;   C0CDATA     - Carrier for the returned structure of the Message
+"RTN","C0CMAIL",225,0)
+ ;  C0CDATA(D0,"SEG")=number of SEGMENTS
+"RTN","C0CMAIL",226,0)
+ ;  C0CDATA(D0,"SEG",0:n)=SEGMENT n details
+"RTN","C0CMAIL",227,0)
+ ;  C0CDATA(D0,"SEG",0:n,"CONTENT",type)=Content details
+"RTN","C0CMAIL",228,0)
+ ;  C0CDATA(D0,"SEG",0:n,"MSG",D3)=Content details
+"RTN","C0CMAIL",229,0)
+ ;  C0CDATA(D0,"SEG",0:n,"HTML",D3)=Content details
+"RTN","C0CMAIL",230,0)
+ ;
+"RTN","C0CMAIL",231,0)
+DETAIL(C0CDATA,C0CINPUT) ; Message Detail Delivery
+"RTN","C0CMAIL",232,0)
+ N LST,D0,D1,U
+"RTN","C0CMAIL",233,0)
+ S U="^"
+"RTN","C0CMAIL",234,0)
+ S D0=+$G(C0CINPUT)
+"RTN","C0CMAIL",235,0)
+ I D0   D    QUIT
+"RTN","C0CMAIL",236,0)
+ . D GETTYP2(D0)
+"RTN","C0CMAIL",237,0)
+ . I $D(LST)   M C0CDATA(D0)=LST
+"RTN","C0CMAIL",238,0)
+ .QUIT
+"RTN","C0CMAIL",239,0)
+ QUIT
+"RTN","C0CMAIL",240,0)
+ ;  ===================
+"RTN","C0CMAIL",241,0)
+ ;  End note if needed
+"RTN","C0CMAIL",242,0)
+ ; MSK   - Set of characters that do not exist in 64 bit encoding
+"RTN","C0CMAIL",243,0)
+GETTYP2(D0) ; Try to get the types and MSK for the 
+"RTN","C0CMAIL",244,0)
+ N I,J,K,N,BCN,BF,CON,CNT,D1,END,FLG,MSK,SEP,SGC,U,XX,ZN,XXNM
+"RTN","C0CMAIL",245,0)
+ S CON="Content-",U="^"
+"RTN","C0CMAIL",246,0)
+ S FLG="--"
+"RTN","C0CMAIL",247,0)
+ S MSK=" !""#$%&'()*,-.:;<>?@[\]^_`{|}~"
+"RTN","C0CMAIL",248,0)
+ S (BF,SEP)=""  ; Start SEP as null, so we can use this to help identify the type
+"RTN","C0CMAIL",249,0)
+ S (BCN,CNT,D1,END,SGC)=0
+"RTN","C0CMAIL",250,0)
+ S XX=$G(^XMB(3.9,D0,0))
+"RTN","C0CMAIL",251,0)
+ ; S K=$P(^XMB(3.9,D0,2,0),U,3)
+"RTN","C0CMAIL",252,0)
+ S LST("TITLE")=$P($G(^XMB(3.9,D0,0)),U,1)
+"RTN","C0CMAIL",253,0)
+ S LST("CREATED")=$$TIME($P(XX,U,3))
+"RTN","C0CMAIL",254,0)
+ F I=4,2 S XXNM=$P(XX,U,I)  Q:$L(XXNM)
+"RTN","C0CMAIL",255,0)
+ S LST("FROM")=$$NAME(XXNM)
+"RTN","C0CMAIL",256,0)
+ ; Get the folks the email is sent to.
+"RTN","C0CMAIL",257,0)
+ S D1=0
+"RTN","C0CMAIL",258,0)
+ F  S D1=$O(^XMB(3.9,D0,1,D1)) Q:'D1  D   Q:D1=""
+"RTN","C0CMAIL",259,0)
+ . N I,T
+"RTN","C0CMAIL",260,0)
+ . S T=$P($G(^XMB(3.9,D0,1,D1,0)),U)
+"RTN","C0CMAIL",261,0)
+ . S:T T=$P($G(^VA(200,T,0)),"^")
+"RTN","C0CMAIL",262,0)
+ . S LST("TO",+D1)=T
+"RTN","C0CMAIL",263,0)
+ . S T=$G(^XMB(3.9,D0,6,+D1,0))
+"RTN","C0CMAIL",264,0)
+ . S:T="" T=$P($G(^VA(200,+T,0)),"^")
+"RTN","C0CMAIL",265,0)
  . S:T="" T="<Unknown>"
-"RTN","C0CMAIL",162,0)
+"RTN","C0CMAIL",266,0)
  . S LST("TO NAME",D1)=T
-"RTN","C0CMAIL",163,0)
+"RTN","C0CMAIL",267,0)
  .QUIT
-"RTN","C0CMAIL",164,0)
- ; Preload first Segment (0) with beginning on Line 1
-"RTN","C0CMAIL",165,0)
- ;  if not a 64bit
-"RTN","C0CMAIL",166,0)
- S LST(NAM,"MSG",D0,"SEG",0)=1
-"RTN","C0CMAIL",167,0)
- S D1=.9999,SEP="--"
-"RTN","C0CMAIL",168,0)
+"RTN","C0CMAIL",268,0)
+ ; Get the Header for the message
+"RTN","C0CMAIL",269,0)
+ S D1=0
+"RTN","C0CMAIL",270,0)
+ F I=1:1 S D1=$O(^XMB(3.9,D0,2,D1)) Q:D1=""  Q:(D1>.99999)   D
+"RTN","C0CMAIL",271,0)
+ . S LST("HDR",I)=$G(^XMB(3.9,D0,2,D1,0))
+"RTN","C0CMAIL",272,0)
+ .QUIT
+"RTN","C0CMAIL",273,0)
+ ; Start walking the different sections
+"RTN","C0CMAIL",274,0)
+ S D1=.99999,SEP="--"
+"RTN","C0CMAIL",275,0)
  F  S D1=$O(^XMB(3.9,D0,2,D1)) Q:'D1  D
-"RTN","C0CMAIL",169,0)
+"RTN","C0CMAIL",276,0)
  . ; Clear any control characters (cr/lf/ff) off
-"RTN","C0CMAIL",170,0)
+"RTN","C0CMAIL",277,0)
  . S X=$TR($G(^XMB(3.9,D0,2,D1,0)),$C(10,12,13))
-"RTN","C0CMAIL",171,0)
+"RTN","C0CMAIL",278,0)
  . ; Enter once to set the SEP to capture the separator
-"RTN","C0CMAIL",172,0)
- . I SEP=FLG&($E(X,1,2)=FLG)&($L(X,FLG)=2)&($L($P(X,FLG,2)>5))   D   Q
-"RTN","C0CMAIL",173,0)
+"RTN","C0CMAIL",279,0)
+ . I (SEP="--")&($E(X,1,2)=FLG)&($L(X,FLG)=2)  D   Q
+"RTN","C0CMAIL",280,0)
  . . S SEP=X,END=X_FLG
-"RTN","C0CMAIL",174,0)
+"RTN","C0CMAIL",281,0)
  . . S (CNT,SGC)=1,BCN=0
-"RTN","C0CMAIL",175,0)
- . . S LST(NAM,"MSG",D0,"SEG",SGC)=D1
-"RTN","C0CMAIL",176,0)
+"RTN","C0CMAIL",282,0)
+ . . S LST("SEG",SGC)=D1
+"RTN","C0CMAIL",283,0)
  . .QUIT
-"RTN","C0CMAIL",177,0)
+"RTN","C0CMAIL",284,0)
  . ;
-"RTN","C0CMAIL",178,0)
- . ; A new separator is set, process original 
-"RTN","C0CMAIL",179,0)
+"RTN","C0CMAIL",285,0)
+ . ; A new SEGMENT separator is set, process original 
+"RTN","C0CMAIL",286,0)
  . I X=SEP  D  QUIT
-"RTN","C0CMAIL",180,0)
- . . S LST(NAM,"MSG",D0,SGC,"SIZE")=BCN
-"RTN","C0CMAIL",181,0)
- . . S LST(NAM,"MSG",D0,"SEG",SGC)=$G(LST(NAM,"MSG",D0,"SEG",SGC))_"^"_(D1-1)
-"RTN","C0CMAIL",182,0)
+"RTN","C0CMAIL",287,0)
+ . . ; Save Current Values
+"RTN","C0CMAIL",288,0)
+ . . S LST("SEG",SGC,"SIZE")=BCN
+"RTN","C0CMAIL",289,0)
+ . . ;  Close this Segment and prepare to start a New Segment
+"RTN","C0CMAIL",290,0)
+ . . S LST("SEG",SGC)=$G(LST("SEG",SGC))_"^"_(D1-1)
+"RTN","C0CMAIL",291,0)
+ . . ;  Put the result in LST("SEG",SGC,"XML")
+"RTN","C0CMAIL",292,0)
+ . . I $L(BF) D
+"RTN","C0CMAIL",293,0)
+ . . . S ZN=1
+"RTN","C0CMAIL",294,0)
+ . . . N I,T,TBF
+"RTN","C0CMAIL",295,0)
+ . . . S TBF=BF
+"RTN","C0CMAIL",296,0)
+ . . . F I=1:1:($L(TBF,"="))  D
+"RTN","C0CMAIL",297,0)
+ . . . . S BF=$P(TBF,"=",I)_"="
+"RTN","C0CMAIL",298,0)
+ . . . . I BF'="="  D DECODER
+"RTN","C0CMAIL",299,0)
+ . . . .QUIT
+"RTN","C0CMAIL",300,0)
+ . . . S BF=""
+"RTN","C0CMAIL",301,0)
+ . . .QUIT
+"RTN","C0CMAIL",302,0)
  . . S SGC=SGC+1,BCN=0
-"RTN","C0CMAIL",183,0)
- . . S LST(NAM,"MSG",D0,"SEG",SGC)=D1
-"RTN","C0CMAIL",184,0)
+"RTN","C0CMAIL",303,0)
+ . . ; Incriment SGC to start a new Segment
+"RTN","C0CMAIL",304,0)
+ . . S LST("SEG",SGC)=D1
+"RTN","C0CMAIL",305,0)
  . .QUIT
-"RTN","C0CMAIL",185,0)
+"RTN","C0CMAIL",306,0)
  . ;
-"RTN","C0CMAIL",186,0)
+"RTN","C0CMAIL",307,0)
+ . ; Accumulate the 64 bit encoding
+"RTN","C0CMAIL",308,0)
+ . I X=$TR(X,MSK)&$L(X) D   Q
+"RTN","C0CMAIL",309,0)
+ . . S BF=BF_X
+"RTN","C0CMAIL",310,0)
+ . . S BCN=BCN+$L(X)
+"RTN","C0CMAIL",311,0)
+ . .QUIT 
+"RTN","C0CMAIL",312,0)
+ . ;
+"RTN","C0CMAIL",313,0)
+ . ; Ending Condition, close out the Segment
+"RTN","C0CMAIL",314,0)
+ . I X=END D  QUIT
+"RTN","C0CMAIL",315,0)
+ . . S LST("SEG",SGC)=$G(LST("SEG",SGC))_"^"_(D1-1)
+"RTN","C0CMAIL",316,0)
+ . . I $L(BF) S ZN=1 D DECODER  S BF="" Q
+"RTN","C0CMAIL",317,0)
+ . .QUIT
+"RTN","C0CMAIL",318,0)
+ . ;
+"RTN","C0CMAIL",319,0)
  . S BCN=BCN+$L(X)
-"RTN","C0CMAIL",187,0)
+"RTN","C0CMAIL",320,0)
+ . ; Split out the Content Info
+"RTN","C0CMAIL",321,0)
  . I X[CON D  Q
-"RTN","C0CMAIL",188,0)
- . . S J=$P($P(X,";"),CON,2)
-"RTN","C0CMAIL",189,0)
- . . S LST(NAM,"MSG",D0,"SEG",SGC,"CONT",CNT,$P(J,":"))=$P(J,":",2)
-"RTN","C0CMAIL",190,0)
+"RTN","C0CMAIL",322,0)
+ . . S J=$P(X,CON,2)
+"RTN","C0CMAIL",323,0)
+ . . S LST("SEG",SGC,"CONTENT",$P(J,":"))=$P(J,":",2,9)
+"RTN","C0CMAIL",324,0)
  . .QUIT
-"RTN","C0CMAIL",191,0)
+"RTN","C0CMAIL",325,0)
  . ;
-"RTN","C0CMAIL",192,0)
- . ; S LST(NAM,"MSG",D0,"SEG",D1)=X
-"RTN","C0CMAIL",193,0)
+"RTN","C0CMAIL",326,0)
+ . ; Everything else is Text
+"RTN","C0CMAIL",327,0)
+ . S LST("SEG",SGC,"TXT",D1)=X
+"RTN","C0CMAIL",328,0)
  .QUIT
-"RTN","C0CMAIL",194,0)
+"RTN","C0CMAIL",329,0)
  QUIT
-"RTN","C0CMAIL",195,0)
+"RTN","C0CMAIL",330,0)
  ;  ===================
-"RTN","C0CMAIL",196,0)
-NAME(NM) ; Return the name of the Sender
-"RTN","C0CMAIL",197,0)
- N NAME
-"RTN","C0CMAIL",198,0)
- S NAME="<Unknown Sender>"
-"RTN","C0CMAIL",199,0)
- D
-"RTN","C0CMAIL",200,0)
- . ; Look first for a value to use with the NEW PERSON file
-"RTN","C0CMAIL",201,0)
- . ;
-"RTN","C0CMAIL",202,0)
- . I NM=+NM S NAME=$P(^VA(200,NM,0),U,1) Q
-"RTN","C0CMAIL",203,0)
- . ;
-"RTN","C0CMAIL",204,0)
- . I $L(NM) S NAME=NM                    Q
-"RTN","C0CMAIL",205,0)
- . ;
-"RTN","C0CMAIL",206,0)
- . ; Else, pull the data from the message and display the foreign source
-"RTN","C0CMAIL",207,0)
- . ;   of the message.
-"RTN","C0CMAIL",208,0)
- . N T
-"RTN","C0CMAIL",209,0)
- . S VAL=$G(^XMB(3.9,D0,.7))
-"RTN","C0CMAIL",210,0)
- . S:VAL T=$P(^VA(200,VAL,0),U)
-"RTN","C0CMAIL",211,0)
- . I $L($G(T)) S NAME=T                  Q
-"RTN","C0CMAIL",212,0)
- . ;
-"RTN","C0CMAIL",213,0)
+"RTN","C0CMAIL",331,0)
+ ; Break down the Buffer Array so it can be saved.
+"RTN","C0CMAIL",332,0)
+ ;  BF is passed in.
+"RTN","C0CMAIL",333,0)
+DECODER ; 
+"RTN","C0CMAIL",334,0)
+ N RCNT,TBF,ZBF,ZI,ZJ,ZK,ZSIZE
+"RTN","C0CMAIL",335,0)
+ S ZBF=BF
+"RTN","C0CMAIL",336,0)
+ ;  Full Buffer, BF, now check for Encryption and Unpack
+"RTN","C0CMAIL",337,0)
+ F RCNT=1:1:$L(ZBF,"=")   D
+"RTN","C0CMAIL",338,0)
+ . N BF
+"RTN","C0CMAIL",339,0)
+ . S BF=$P(ZBF,"=",RCNT)
+"RTN","C0CMAIL",340,0)
+ . ;  Unpacking the 64 bit encoding
+"RTN","C0CMAIL",341,0)
+ . S TBF=$TR($$DECODE^RGUTUU(BF),$C(10,12,13))
+"RTN","C0CMAIL",342,0)
+ . D:$L(TBF)
+"RTN","C0CMAIL",343,0)
+ . . N XBF
+"RTN","C0CMAIL",344,0)
+ . . S BF=BF_"="
+"RTN","C0CMAIL",345,0)
+ . . D NORMAL(.XBF,.TBF)
+"RTN","C0CMAIL",346,0)
+ . . M LST("SEG",SGC,"XML",RCNT)=XBF
+"RTN","C0CMAIL",347,0)
+ . .QUIT
+"RTN","C0CMAIL",348,0)
  .QUIT
-"RTN","C0CMAIL",214,0)
- QUIT NAME
-"RTN","C0CMAIL",215,0)
+"RTN","C0CMAIL",349,0)
+ QUIT
+"RTN","C0CMAIL",350,0)
  ;  ===================
-"RTN","C0CMAIL",216,0)
-TIME(Y) ; The time and date of the sending
-"RTN","C0CMAIL",217,0)
- X ^DD("DD")
-"RTN","C0CMAIL",218,0)
- QUIT Y
-"RTN","C0CMAIL",219,0)
+"RTN","C0CMAIL",351,0)
+ ;  OUTXML = OUTBF  = OUT   = OUTPUT ARRAY TO BE BUILT
+"RTN","C0CMAIL",352,0)
+ ;  BF     = INXML = INPUT ARRAY TO PROVIDE INPUT
+"RTN","C0CMAIL",353,0)
+ ;   >D NORMAL^C0CMAIL(.OUT,BF)
+"RTN","C0CMAIL",354,0)
+NORMAL(OUTXML,INXML)    ;NORMALIZES AN XML STRING PASSED BY NAME IN INXML
+"RTN","C0CMAIL",355,0)
+ ; INTO AN XML ARRAY RETURNED IN OUTXML, ALSO PASSED BY NAME
+"RTN","C0CMAIL",356,0)
+ ;
+"RTN","C0CMAIL",357,0)
+ N ZN,OUTBF
+"RTN","C0CMAIL",358,0)
+ S ZN=1
+"RTN","C0CMAIL",359,0)
+ S OUTBF(ZN)=$P(INXML,"><",ZN)_">"
+"RTN","C0CMAIL",360,0)
+ F ZN=ZN+1:1 S OUTBF(ZN)="<"_$P(INXML,"><",ZN) Q:$P(INXML,"><",ZN+1)=""  D  ;
+"RTN","C0CMAIL",361,0)
+ . S OUTBF(ZN)=OUTBF(ZN)_">"
+"RTN","C0CMAIL",362,0)
+ .QUIT
+"RTN","C0CMAIL",363,0)
+ M OUTXML=OUTBF
+"RTN","C0CMAIL",364,0)
+ QUIT
+"RTN","C0CMAIL",365,0)
  ;  ===================
-"RTN","C0CMAIL",220,0)
- ;  Segments in Message need to be identified and decoded properly
-"RTN","C0CMAIL",221,0)
- ; D DETAIL^C0CMAIL(.ARRAY,D0) ;  Call One for each message
-"RTN","C0CMAIL",222,0)
- ;   ARRAY will have the details of this one call
-"RTN","C0CMAIL",223,0)
- ;    
-"RTN","C0CMAIL",224,0)
- ; Inputs;
-"RTN","C0CMAIL",225,0)
- ;   C0CINPUT    - The IEN of the message to expand
-"RTN","C0CMAIL",226,0)
- ; Outputs;
-"RTN","C0CMAIL",227,0)
- ;   C0CDATA     - Carrier for the returned structure of the Message
-"RTN","C0CMAIL",228,0)
- ;  C0CDATA(D0,"SEG")=number of SEGMENTS
-"RTN","C0CMAIL",229,0)
- ;  C0CDATA(D0,"SEG",0:n)=SEGMENT n details
-"RTN","C0CMAIL",230,0)
- ;  C0CDATA(D0,"SEG",0:n,"CONTENT",type)=Content details
-"RTN","C0CMAIL",231,0)
- ;  C0CDATA(D0,"SEG",0:n,"MSG",D3)=Content details
-"RTN","C0CMAIL",232,0)
- ;  C0CDATA(D0,"SEG",0:n,"HTML",D3)=Content details
-"RTN","C0CMAIL",233,0)
- ;
-"RTN","C0CMAIL",234,0)
-DETAIL(C0CDATA,C0CINPUT) ; Message Detail Delivery
-"RTN","C0CMAIL",235,0)
- N LST,D0,D1,U
-"RTN","C0CMAIL",236,0)
- S U="^"
-"RTN","C0CMAIL",237,0)
- S D0=+$G(C0CINPUT)
-"RTN","C0CMAIL",238,0)
- I D0   D    QUIT
-"RTN","C0CMAIL",239,0)
- . D GETTYP2(D0)
-"RTN","C0CMAIL",240,0)
- . I $D(LST)   M C0CDATA(D0)=LST
-"RTN","C0CMAIL",241,0)
- .QUIT
-"RTN","C0CMAIL",242,0)
+"RTN","C0CMAIL",366,0)
+ ;  vvvvvvvvvvvvvvv  Not Needed  vvvvvvvvvvvvvvvvvvvvvvvvvv
+"RTN","C0CMAIL",367,0)
+ ;  End note if needed
+"RTN","C0CMAIL",368,0)
  QUIT
-"RTN","C0CMAIL",243,0)
- ;  ===================
-"RTN","C0CMAIL",244,0)
- ;  End note if needed
-"RTN","C0CMAIL",245,0)
- ; MSK   - Set of characters that do not exist in 64 bit encoding
-"RTN","C0CMAIL",246,0)
-GETTYP2(D0) ; Try to get the types and MSK for the 
-"RTN","C0CMAIL",247,0)
- N I,J,K,N,BCN,BF,CON,CNT,D1,END,FLG,MSK,SEP,SGC,U,XX,ZN,XXNM
-"RTN","C0CMAIL",248,0)
- S CON="Content-",U="^"
-"RTN","C0CMAIL",249,0)
- S FLG="--"
-"RTN","C0CMAIL",250,0)
- S MSK=" !""#$%&'()*,-.:;<>?@[\]^_`{|}~"
-"RTN","C0CMAIL",251,0)
- S (BF,SEP)=""  ; Start SEP as null, so we can use this to help identify the type
-"RTN","C0CMAIL",252,0)
- S (BCN,CNT,D1,END,SGC)=0
-"RTN","C0CMAIL",253,0)
- S XX=$G(^XMB(3.9,D0,0))
-"RTN","C0CMAIL",254,0)
- ; S K=$P(^XMB(3.9,D0,2,0),U,3)
-"RTN","C0CMAIL",255,0)
- S LST("TITLE")=$P($G(^XMB(3.9,D0,0)),U,1)
-"RTN","C0CMAIL",256,0)
- S LST("CREATED")=$$TIME($P(XX,U,3))
-"RTN","C0CMAIL",257,0)
- F I=4,2 S XXNM=$P(XX,U,I)  Q:$L(XXNM)
-"RTN","C0CMAIL",258,0)
- S LST("FROM")=$$NAME(XXNM)
-"RTN","C0CMAIL",259,0)
- ; Get the folks the email is sent to.
-"RTN","C0CMAIL",260,0)
- S D1=0
-"RTN","C0CMAIL",261,0)
- F  S D1=$O(^XMB(3.9,D0,1,D1)) Q:'D1  D   Q:D1=""
-"RTN","C0CMAIL",262,0)
- . N I,T
-"RTN","C0CMAIL",263,0)
- . S T=$P($G(^XMB(3.9,D0,1,D1,0)),U)
-"RTN","C0CMAIL",264,0)
- . S:T T=$P($G(^VA(200,T,0)),"^")
-"RTN","C0CMAIL",265,0)
- . S LST("TO",+D1)=T
-"RTN","C0CMAIL",266,0)
- . S T=$G(^XMB(3.9,D0,6,+D1,0))
-"RTN","C0CMAIL",267,0)
- . S:T="" T=$P($G(^VA(200,+T,0)),"^")
-"RTN","C0CMAIL",268,0)
- . S:T="" T="<Unknown>"
-"RTN","C0CMAIL",269,0)
- . S LST("TO NAME",D1)=T
-"RTN","C0CMAIL",270,0)
- .QUIT
-"RTN","C0CMAIL",271,0)
- ; Get the Header for the message
-"RTN","C0CMAIL",272,0)
- S D1=0
-"RTN","C0CMAIL",273,0)
- F I=1:1 S D1=$O(^XMB(3.9,D0,2,D1)) Q:D1=""  Q:(D1>.99999)   D
-"RTN","C0CMAIL",274,0)
- . S LST("HDR",I)=$G(^XMB(3.9,D0,2,D1,0))
-"RTN","C0CMAIL",275,0)
- .QUIT
-"RTN","C0CMAIL",276,0)
- ; Start walking the different sections
-"RTN","C0CMAIL",277,0)
- S D1=.99999,SEP="--"
-"RTN","C0CMAIL",278,0)
- F  S D1=$O(^XMB(3.9,D0,2,D1)) Q:'D1  D
-"RTN","C0CMAIL",279,0)
- . ; Clear any control characters (cr/lf/ff) off
-"RTN","C0CMAIL",280,0)
- . S X=$TR($G(^XMB(3.9,D0,2,D1,0)),$C(10,12,13))
-"RTN","C0CMAIL",281,0)
- . ; Enter once to set the SEP to capture the separator
-"RTN","C0CMAIL",282,0)
- . I (SEP="--")&($E(X,1,2)=FLG)&($L(X,FLG)=2)  D   Q
-"RTN","C0CMAIL",283,0)
- . . S SEP=X,END=X_FLG
-"RTN","C0CMAIL",284,0)
- . . S (CNT,SGC)=1,BCN=0
-"RTN","C0CMAIL",285,0)
- . . S LST("SEG",SGC)=D1
-"RTN","C0CMAIL",286,0)
- . .QUIT
-"RTN","C0CMAIL",287,0)
- . ;
-"RTN","C0CMAIL",288,0)
- . ; A new SEGMENT separator is set, process original 
-"RTN","C0CMAIL",289,0)
- . I X=SEP  D  QUIT
-"RTN","C0CMAIL",290,0)
- . . ; Save Current Values
-"RTN","C0CMAIL",291,0)
- . . S LST("SEG",SGC,"SIZE")=BCN
-"RTN","C0CMAIL",292,0)
- . . ;  Close this Segment and prepare to start a New Segment
-"RTN","C0CMAIL",293,0)
- . . S LST("SEG",SGC)=$G(LST("SEG",SGC))_"^"_(D1-1)
-"RTN","C0CMAIL",294,0)
- . . ;  Put the result in LST("SEG",SGC,"XML")
-"RTN","C0CMAIL",295,0)
- . . I $L(BF) D
-"RTN","C0CMAIL",296,0)
- . . . S ZN=1
-"RTN","C0CMAIL",297,0)
- . . . N I,T,TBF
-"RTN","C0CMAIL",298,0)
- . . . S TBF=BF
-"RTN","C0CMAIL",299,0)
- . . . F I=1:1:($L(TBF,"="))  D
-"RTN","C0CMAIL",300,0)
- . . . . S BF=$P(TBF,"=",I)_"="
-"RTN","C0CMAIL",301,0)
- . . . . I BF'="="  D DECODER
-"RTN","C0CMAIL",302,0)
- . . . .QUIT
-"RTN","C0CMAIL",303,0)
- . . . S BF=""
-"RTN","C0CMAIL",304,0)
- . . .QUIT
-"RTN","C0CMAIL",305,0)
- . . S SGC=SGC+1,BCN=0
-"RTN","C0CMAIL",306,0)
- . . ; Incriment SGC to start a new Segment
-"RTN","C0CMAIL",307,0)
- . . S LST("SEG",SGC)=D1
-"RTN","C0CMAIL",308,0)
- . .QUIT
-"RTN","C0CMAIL",309,0)
- . ;
-"RTN","C0CMAIL",310,0)
- . ; Accumulate the 64 bit encoding
-"RTN","C0CMAIL",311,0)
- . I X=$TR(X,MSK)&$L(X) D   Q
-"RTN","C0CMAIL",312,0)
- . . S BF=BF_X
-"RTN","C0CMAIL",313,0)
- . . S BCN=BCN+$L(X)
-"RTN","C0CMAIL",314,0)
- . .QUIT 
-"RTN","C0CMAIL",315,0)
- . ;
-"RTN","C0CMAIL",316,0)
- . ; Ending Condition, close out the Segment
-"RTN","C0CMAIL",317,0)
- . I X=END D  QUIT
-"RTN","C0CMAIL",318,0)
- . . S LST("SEG",SGC)=$G(LST("SEG",SGC))_"^"_(D1-1)
-"RTN","C0CMAIL",319,0)
- . . I $L(BF) S ZN=1 D DECODER  S BF="" Q
-"RTN","C0CMAIL",320,0)
- . .QUIT
-"RTN","C0CMAIL",321,0)
- . ;
-"RTN","C0CMAIL",322,0)
- . S BCN=BCN+$L(X)
-"RTN","C0CMAIL",323,0)
- . ; Split out the Content Info
-"RTN","C0CMAIL",324,0)
- . I X[CON D  Q
-"RTN","C0CMAIL",325,0)
- . . S J=$P(X,CON,2)
-"RTN","C0CMAIL",326,0)
- . . S LST("SEG",SGC,"CONTENT",$P(J,":"))=$P(J,":",2,9)
-"RTN","C0CMAIL",327,0)
- . .QUIT
-"RTN","C0CMAIL",328,0)
- . ;
-"RTN","C0CMAIL",329,0)
- . ; Everything else is Text
-"RTN","C0CMAIL",330,0)
- . S LST("SEG",SGC,"TXT",D1)=X
-"RTN","C0CMAIL",331,0)
- .QUIT
-"RTN","C0CMAIL",332,0)
- QUIT
-"RTN","C0CMAIL",333,0)
- ;  ===================
-"RTN","C0CMAIL",334,0)
- ; Break down the Buffer Array so it can be saved.
-"RTN","C0CMAIL",335,0)
- ;  BF is passed in.
-"RTN","C0CMAIL",336,0)
-DECODER ; 
-"RTN","C0CMAIL",337,0)
- N RCNT,TBF,ZBF,ZI,ZJ,ZK,ZSIZE
-"RTN","C0CMAIL",338,0)
- S ZBF=BF
-"RTN","C0CMAIL",339,0)
- ;  Full Buffer, BF, now check for Encryption and Unpack
-"RTN","C0CMAIL",340,0)
- F RCNT=1:1:$L(ZBF,"=")   D
-"RTN","C0CMAIL",341,0)
- . N BF
-"RTN","C0CMAIL",342,0)
- . S BF=$P(ZBF,"=",RCNT)
-"RTN","C0CMAIL",343,0)
- . ;  Unpacking the 64 bit encoding
-"RTN","C0CMAIL",344,0)
- . S TBF=$TR($$DECODE^RGUTUU(BF),$C(10,12,13))
-"RTN","C0CMAIL",345,0)
- . D:$L(TBF)
-"RTN","C0CMAIL",346,0)
- . . N XBF
-"RTN","C0CMAIL",347,0)
- . . S BF=BF_"="
-"RTN","C0CMAIL",348,0)
- . . D NORMAL(.XBF,.TBF)
-"RTN","C0CMAIL",349,0)
- . . M LST("SEG",SGC,"XML",RCNT)=XBF
-"RTN","C0CMAIL",350,0)
- . .QUIT
-"RTN","C0CMAIL",351,0)
- .QUIT
-"RTN","C0CMAIL",352,0)
- QUIT
-"RTN","C0CMAIL",353,0)
- ;  ===================
-"RTN","C0CMAIL",354,0)
- ;  OUTXML = OUTBF  = OUT   = OUTPUT ARRAY TO BE BUILT
-"RTN","C0CMAIL",355,0)
- ;  BF     = INXML = INPUT ARRAY TO PROVIDE INPUT
-"RTN","C0CMAIL",356,0)
- ;   >D NORMAL^C0CMAIL(.OUT,BF)
-"RTN","C0CMAIL",357,0)
-NORMAL(OUTXML,INXML)    ;NORMALIZES AN XML STRING PASSED BY NAME IN INXML
-"RTN","C0CMAIL",358,0)
- ; INTO AN XML ARRAY RETURNED IN OUTXML, ALSO PASSED BY NAME
-"RTN","C0CMAIL",359,0)
- ;
-"RTN","C0CMAIL",360,0)
- N ZN,OUTBF
-"RTN","C0CMAIL",361,0)
- S ZN=1
-"RTN","C0CMAIL",362,0)
- S OUTBF(ZN)=$P(INXML,"><",ZN)_">"
-"RTN","C0CMAIL",363,0)
- F ZN=ZN+1:1 S OUTBF(ZN)="<"_$P(INXML,"><",ZN) Q:$P(INXML,"><",ZN+1)=""  D  ;
-"RTN","C0CMAIL",364,0)
- . S OUTBF(ZN)=OUTBF(ZN)_">"
-"RTN","C0CMAIL",365,0)
- .QUIT
-"RTN","C0CMAIL",366,0)
- M OUTXML=OUTBF
-"RTN","C0CMAIL",367,0)
- QUIT
-"RTN","C0CMAIL",368,0)
- ;  ===================
 "RTN","C0CMAIL",369,0)
- ;  vvvvvvvvvvvvvvv  Not Needed  vvvvvvvvvvvvvvvvvvvvvvvvvv
-"RTN","C0CMAIL",370,0)
- ;  End note if needed
-"RTN","C0CMAIL",371,0)
- QUIT
-"RTN","C0CMAIL",372,0)
  ;  ===================
 "RTN","C0CMAIL2")
-0^82^B166788518
+0^82^B165067910
 "RTN","C0CMAIL2",1,0)
 C0CMAIL2 ; Communications for MIME Documents and MultiMIME ; 3110420 ; rcr/rcr  ; 5/10/12 2:50pm
 "RTN","C0CMAIL2",2,0)
- ;;1.2;C0C;;May 11, 2012;Build 50
+ ;;1.2;CCD/CCR GENERATION UTILITIES;;Oct 30, 2012;Build 51
 "RTN","C0CMAIL2",3,0)
  ;Copyright 2011 Chris Richardson, Richardson Computer Research
